<?php
/*
** (c) 2001-2007 - NetSlave GmbH, www.netslave.de
** 
** Die cKonto XML API als PHP Funktion nutzen
** Benutzt cURL & SimpleXML - (POST-Request)
*/



// hier den cKonto key einfuegen
$key = "demo";

// abfrage kontonummer & bankleitzahl
$query = "key={$key}&kontonummer=539290858&bankleitzahl=12030000";

/*
// abfrage kontonummer & bankleitzahl mit bic rueckgabe
$query = "key={$key}&kontonummer=539290858&bankleitzahl=12030000&sepa=1";
*/

/*
// abfrage iban mit bic rueckgabe
$query = "key={$key}&iban=DE69120300000539290858&sepa=1";
*/


// Aufruf der Funktion mit KTO und BLZ
$c = ckonto($query, $key);

// konvertierung von object zu array
$c = xml2array($c);


/*
$c enhält die Rückgabewerte als Array
(Testausgabe möglich über den Befehl: print_r($c);

Beispiel:
Array
(
    [status] => 1
    [zip] => 10117
    [location] => Berlin
    [bank] => Deutsche Kreditbank Berlin
    [kto] => 539290858
    [blz] => 12030000
    [iban] => DE69120300000539290858
    [bic] => BYLADEM1001
)
*/

// Beispiel verarbeitung:

print "Die Überprüfung des Kontos (KTO: $c[kto] - BLZ: $c[blz]) ergab:\n";

if ($c["status"] == 1){

    // Kontonummer okay:

    print "Die Kontonummer ist gültig, sie kann von diesem Institut ($c[bank]) vergeben werden\n";

}
else {

    // Die Kontonummer ist falsch

    // Rückgabewert auswerten (für die Fehlermeldung)
    switch($c["status"]){
        case 0; print "Die Kontonummer ist ungültig, sie kann von diesem Institut nicht vergeben werden"; break;
        case 2; print "Fehler bei der Eingabe der Bankleitzahl (Sie ist entweder nicht 8-stellig oder enthält Buchstaben)"; break;
        case 3; print "Fehler bei der Eingabe der Kontonummer (Sie ist entweder zu lang oder enthält Buchstaben"; break;
        case 4; print "Eingabefehler bei der Kontonummer und Bankleitzahl"; break;
        case 5; print "Genereller Eingabefehler des Übergabeparameters - enthält evtl. Leerzeichen"; break;
        case 6; print "Fehler im Format des Übergabeparameters"; break;
        case 7; print "Die Bankleitzahl wurde in der Datenbank nicht gefunden (existiert nicht)"; break;
        case 8; print "Die von der Bank verwendete Prüfmethode ist im Demonstrations-Modus nicht verfügbar"; break;
        case 9; print "Die Kontonummer kann nicht geprüft werden, da die Bank entweder keine Prüfziffern verwendet oder es sich um eine spezielle Kontonummer handelt"; break;
        default: print "Unbekannter Rückgabewert."; break;
    }

}


function ckonto($query, $key = 'demo'){

    $url = "https://www.ckonto.de/webservice.cgi"; 

    // get results per curl
    $ch = curl_init();
   
    // curl options
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $query);
    curl_setopt($ch, CURLOPT_USERAGENT, 'cKonto-PHP');
    
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
    curl_setopt($ch, CURLOPT_TIMEOUT, 15);
    
    
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    
    // error logfile
    // curl_setopt($ch, CURLOPT_STDERR, "./curl.error.log");
   
    // curl exec & query URL
    $result = curl_exec($ch);
   
    // close curl handle
    curl_close($ch);

    
    $p = simplexml_load_string($result);

    return $p;

}

function xml2array ( $xmlObject, $out = array () )
{
    foreach ( (array) $xmlObject as $index => $node ){
        if(empty($node)){
            $out[$index] = '';
            continue;
        }
        $out[$index] = ( is_object ( $node ) ) ? xml2array ( $node ) : $node;
    }

    return $out;
}
?>
